const baseUrl: string = "https://0x0.st"
const id: string = "a0eiaje" // < unicode > 
const key: string = "LhBRttf+oI/PNHyTBrPa7HGDK/uC9fcMkGGgz63zT4Y=" // 32 bytes b64
const completeUrl: string = baseUrl + "/" + id + "#" + key
console.log(completeUrl);
const urlObj:URL = new URL(completeUrl);

/** will return a tuple of the key and id if valid 
 * 1 if no id ( creator ) 
 * 2 if encryption key is missing /  wrong length
 * 3 if key is malformed
 */
function validUrl(url: URL): [string,Uint8Array] | number {
	var key: string
	try {
		key = atob(url.hash.substring(1))
	} catch(e) {
		return 3
	}
	const id: string = url.pathname.substring(1);
	if ( id === "/" ) {
		return 1
	}
	const binKey = binaryToArray(key)
	if ( key.length === 32 ) {
		return [id,binKey]
	}
	else { 
		return 2 
	}
}

function binaryToArray(raw: string): Uint8Array {
  var rawLength = raw.length;
  var array = new Uint8Array(new ArrayBuffer(rawLength));

  for(var i = 0; i < rawLength; i++) {
    array[i] = raw.charCodeAt(i);
  }
  return array;
}

console.log(validUrl(urlObj));
